package ass.sivakfil.hw6.cache;

import java.io.IOException;
import java.io.OutputStream;

/** 
 * Represents a response that can write itself to given OutputStream using method writeResponse.
 * */
public interface IResponse {
	
	/**
	 * @return true if this response can be cached. 
	 * One might want to return false for all error responses so that they are not cached
	 */
	boolean isCacheable();
	
	
	/**
	 * @return request associated with this response
	 */
	IRequest getRequest();
	
	
	/**
	 * Writes response to given output stream
	 * @param os - output stream where output should be written
	 * @throws IOException
	 */
	void writeResponse(OutputStream os) throws IOException;
	
}
