package ass.sivakfil.hw6.cache.impl;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;

import org.apache.commons.io.IOUtils;

import io.reactivex.Observable;
import ass.sivakfil.hw6.cache.IRequest;
import ass.sivakfil.hw6.cache.IRequestHandler;
import ass.sivakfil.hw6.cache.IResponse;

class FileResponse implements IResponse {

	protected String filePath;
	
	public FileResponse(String filePath) {
		super();
		this.filePath = filePath;
	}

	@Override
	public boolean isCacheable() {
		return false;
	}

	@Override
	public IRequest getRequest() {
		return null;
	}

	@Override
	public void writeResponse(OutputStream os) throws IOException {
		IOUtils.copy(new FileInputStream(filePath), os);
	}
}

public class PrimitiveRequestHandler implements IRequestHandler {
	@Override
	public Observable<IResponse> handleRequests(Observable<IRequest> requestObs) {
		return requestObs
		.map(r -> r.getKey())
		.map(FileResponse::new);
	}
}
