package ass.sivakfil.hw6.cache.impl;

import io.reactivex.Observable;

import java.io.ByteArrayOutputStream;

import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import ass.sivakfil.hw6.cache.IRequest;
import ass.sivakfil.hw6.cache.IRequestHandler;
import ass.sivakfil.hw6.cache.IResponse;

public class CachedReactiveRequestHandlerTest {

	protected IRequestHandler handler;
	
	@BeforeMethod
	public void setup() {
		// TODO: replace with your own implementation
		handler = new PrimitiveRequestHandler();
	}
	
	@Test
	public void testHandleRequests() {
		Observable<IRequest> request = Observable.just("helloworld.txt", "helloworld.txt")
		.map(s -> () -> s);
		
		handler.handleRequests(request)
		.map(resp -> strFromResponse(resp))
		.test()	// converts observable into TestObserver with assert methods
		.assertNoErrors()
		.assertComplete()
		.assertValues("hello world", "hello world");
	}
		
	protected static String strFromResponse(IResponse resp) {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		try {
			resp.writeResponse(baos);
			return new String(baos.toByteArray(), "UTF-8").trim();
		}catch(Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
